library IEEE; 
use IEEE.std_logic_1164.all; 
library xc4000; 
use xc4000.components.all; 
library synplify; 
use synplify.attributes.all; 

entity rom_16x1 is 
 generic (init_val : string := "0000" ); 
 port (O : out std_logic; 
       A3, A2, A1, A0: in std_logic); 
end rom_16x1; 

architecture xilinx of rom_16x1 is 

 attribute xc_props : string; 
 attribute xc_props of u1 : label is "INIT=" & init_val; 

begin 

U1 : ROM16X1 port map (O => O, A0 => A0, A1 => A1, A2 => A2, A3 => A3); 

end xilinx; 

library IEEE; 
use IEEE.std_logic_1164.all; 
use IEEE.std_logic_unsigned.all; 

entity rom_16x8 is  port (o: out std_logic_vector(7 downto 0); 
                          a: in std_logic_vector(3 downto 0)); 
end rom_16x8; 

architecture xilinx of rom_16x8 is 

component rom_16x1 
generic (init_val: string := "0000"); 
port (O : out std_logic; 
      A3, A2, A1, A0 : in std_logic); 
end component; 

begin 

U0 : rom_16x1 generic map ("FFFF") 
              port map (O => o(0), A0 => a(0), A1 => a(1), A2 => a(2), A3 => a(3)); 
U1 : rom_16x1 generic map ("ABCD") 
              port map (O => o(1), A0 => a(0), A1 => a(1), A2 => a(2), A3 => a(3)); 
U2 : rom_16x1 generic map ("BCDE") 
              port map (O => o(2), A0 => a(0), A1 => a(1), A2 => a(2), A3 => a(3)); 
U3 : rom_16x1 generic map ("CDEF") 
              port map (O => o(3), A0 => a(0), A1 => a(1), A2 => a(2), A3 => a(3)); 
U4 : rom_16x1 generic map ("CCDD") 
              port map (O => o(4), A0 => a(0), A1 => a(1), A2 => a(2), A3 => a(3)); 
U5 : rom_16x1 generic map ("0000") 
              port map (O => o(5), A0 => a(0), A1 => a(1), A2 => a(2), A3 => a(3)); 
U6 : rom_16x1 generic map ("0010") 
              port map (O => o(6), A0 => a(0), A1 => a(1), A2 => a(2), A3 => a(3)); 
U7 : rom_16x1 generic map ("1100") 
               port map (O => o(7), A0 => a(0), A1 => a(1), A2 => a(2), A3 => a(3)); 

end xilinx; 

