--
--  GEN_ENV.vhd
--
--  GENERATOR of ENVELOPE.
--
--        Copyright (C)2001 SEILEBOST
--                   All rights reserved.
--
-- $Id: GEN_ENV.vhd, v0.2 2001/11/02 00:00:00 SEILEBOST $
--

-- NO TESTED !!

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity gen_env is
    Port ( CLK_ENV      : in    std_logic;
           DATA         : in    std_logic_vector(3 downto 0);
           RST          : in    std_logic;
           WR           : in    std_logic;
           CS           : in    std_logic;
           OUT_DATA     : out   std_logic_vector(3 downto 0) );
end gen_env;

architecture Behavioral of gen_env is

SIGNAL COUNT : std_logic_vector(3 downto 0);
SIGNAL DIR   : std_logic;

begin


 PROCESS(CLK_ENV, RST)
 BEGIN
    if (RST = '1') then  -- Reset
       count    <= "0000";
       DIR      <= '1';
       OUT_DATA <= "0000";
    elsif (CLK_ENV'event and CLK_ENV = '1') then -- edge clock
       if (WR = '1' AND CS = '1') then -- Write to register
          if (DATA(2) = '0') then 
             count <= "1111";
             DIR   <= '0';
          else
             count <= "0000";
             DIR   <= '1';
          end if;
       elsif (count = "0000") then  -- the treatment
             if (DATA(3) = '0') then
                OUT_DATA <= "0000";
--                      count    <= "0000"; ??
             elsif (DATA(0) = '1') then  -- hold = 1
                   if (DATA(0) = DATA(1)) then
                      OUT_DATA <= "0000";
--                      count    <= "0000"; ??
                      DIR      <= '1';
                   else 
                      OUT_DATA <= "1111";
                      count    <= "1111";
                      DIR      <= '0';
                   end if;                        
             else
                   if (DATA(0) = DATA(1)) then
                      OUT_DATA <= "1111";
                      count    <= "1111"; 
                      if (DATA(0) = '0') then 
                         DIR <= '1';
                      else
                         DIR <= '0';
                      end if;
                   else
                       count <= count xor "1111";
                       DIR   <= not DIR;
                   end if;
             end if;
         else
             if (DIR = '1') then 
                count <= count + 1;
             else
                count <= count - 1;
             end if;
             
             OUT_DATA <= count;
         end if;
    end if; -- fin elsif
 END PROCESS;

end Behavioral;
