--
--  NOISE_GENERATOR.vhd
--
--  Generator a noise tone.
--
--        Copyright (C)2001 SEILEBOST
--                   All rights reserved.
--
-- $Id: NOISE_GENERATOR.vhd, v0.2 2001/11/02 00:00:00 SEILEBOST $
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity noise_generator is
    Port ( CLK          : in     std_logic;
           RST          : in     std_logic;
           WR           : in     std_logic;
           CS           : in     std_logic;
           DATA         : in     std_logic_vector(4 downto 0);
           OUT_N        : out    std_logic );
end noise_generator;

architecture Behavioral of noise_generator is

SIGNAL COUNT     : std_logic_vector(17 downto 0);
SIGNAL OUT_N_TMP : std_logic;

begin
 PROCESS(CLK, RST, WR, CS)
 BEGIN
     if (RST = '1') then
        COUNT     <= "000000000000000000";
        OUT_N_TMP <= '0';
        OUT_N     <= '0';
     elsif (CLK'event and CLK = '1') then
        if (WR = '1' and CS = '1') then
           COUNT(4 downto 0) <= DATA;
        else
           COUNT <= COUNT + 1;
           if (COUNT(1) = '1') then
              OUT_N_TMP <= NOT OUT_N_TMP;
              OUT_N     <= OUT_N_TMP;
           end if;
           if (COUNT(0) = '1') then
              COUNT <= "101000000000000000";
           end if;
           COUNT(16 downto 0) <= COUNT(17 downto 1);
           COUNT(17)          <= COUNT(0);
        end if;
    end if;
 END PROCESS;
end Behavioral;
